clear all;

files = {'11.jpg', '12.jpg', '21.jpg', '22.jpg', '31.jpg', '32.jpg',...
         '41.jpg', '42.jpg', '51.jpg', '52.jpg', '61.jpg', '62.jpg'};
     
stack = [];         
numimages = numel(files);

% read our images...
for i = 1: numimages
   img = double(imread(char(files(i))));
   stack = cat(3, stack, img);
end

[vectors, coordinates] = imstack2vectors(stack);

P= {};
for i = 1: 12
   P{i} = princomp(vectors, i);
end

% %
% for pcq = 1:12
%     for i = 1:12
%         h1 = P{pcq}.X(:, i);
%         h1 = reshape(h1, 64, 64);
%         figure;
%         imshow(h1, []);
%     end
% end

% compute distances between original images and reconstructed images... 
% euclidean and cosine distances between all the principle component
% images...

% Compute distances between pc images 7 and 11
euclidean_distance7 = zeros(numimages, numimages);
cos_sim7 = zeros(numimages, numimages);
for j = 1: 12
   for i = 1: 12    
      euclidean_distance7(i, j) = norm(P{7}.X(:, i) - P{7}.X(:, j));
      cos_sim7(i, j) = dot(P{7}.X(:,i), P{7}.X(:, j)) /...
           (norm(P{7}.X(:, i))*norm(P{7}.X(:, j)));
   end
end

euclidean_distance11 = zeros(numimages, numimages);
cos_sim11 = zeros(numimages, numimages);
for j = 1: 12
   for i = 1: 12    
      euclidean_distance11(i, j) = norm(P{11}.X(:, i) - P{11}.X(:, j));
      cos_sim11(i, j) = dot(P{11}.X(:,i), P{11}.X(:, j)) /...
           (norm(P{11}.X(:, i))*norm(P{11}.X(:, j)));
   end
end

% Compute distances between pc images 7 and 11 and real images
euclidean_distance7r = zeros(numimages, numimages);
cos_sim7r = zeros(numimages, numimages);
for j = 1: 12
   for i = 1: 12    
      euclidean_distance7r(i, j) = norm(vectors(i) - P{7}.X(:, j));
      cos_sim7r(i, j) = dot(vectors(:,i), P{7}.X(:, j)) /...
           (norm(vectors(:,i))*norm(P{7}.X(:, j)));
   end
end

euclidean_distance11r = zeros(numimages, numimages);
cos_sim11r = zeros(numimages, numimages);
for j = 1: 12
   for i = 1: 12    
      euclidean_distance11r(i, j) = norm(vectors(:,i) - P{11}.X(:, j));
      cos_sim11r(i, j) = dot(vectors(:,i), P{11}.X(:, j)) /...
           (norm(vectors(:,i))*norm(P{11}.X(:, j)));
   end
end
euclidean_distance11r
cos_sim11r
euclidean_distance7r
cos_sim7r

